<template>
  <Row class="investor-news">
    <stock-list-page :search-columns="searchColumns"
                     :table-columns="tableColumns"
                     :table-data="tableData"
                     :total-data-amount="totalData"
                     :page-size-options="[30]"
                     :default-page-at="pageAt"
                     @search="getDailyNewsAction">
      <Row>
        <DatePicker type="date" placeholder="Select date"
                    fomat="yyyy/MM/dd" v-model="date" @on-change="getDailyNewsAction({})">
        </DatePicker>
      </Row>
    </stock-list-page>
  </Row>
</template>

<script>
import StockListPage from "../../../components/StockListPage";
import { columns } from '../../../helpers/list';
import { validators as api } from '../../../configs/request-validator/company-news';

const actions = {
  async getDailyNewsAction(filter) {
    const hasDate = !!this.date;
    if (hasDate) {
      const date = (this.date).toLocaleDateString();
      filter.pageAt = (date !== this.lastDate) ? 1 : filter.pageAt;
      const requestData = {
        pageAt: filter.pageAt,
        pageSize: filter.pageSize || 30,
        timestamp: (new Date(`${date} 00:00:00`)).getTime(),
      };
      this.$conditionMutator(requestData, filter);
      this.pageAt = filter.pageAt;
      this.lastDate = date;

      try {
        const { data } = await this.$api(api.AccessDailyNewsRequest, requestData);
        const hasData = data['news'].length > 0;
        if (hasData) {
          this.tableData = data['news'];
          this.totalData = data['total'];
        } else {
          this.tableData = undefined;
          this.totalData = 0;
          this.$Notice.error({
            title: 'News Error',
            desc: `No news at ${date}`,
          });
        }
      } catch (error) {
        this.$apiErrorHandler(error);
      }
    }
  },
};

export default {
  name: "news",
  components: {StockListPage},
  data() {
    return {
      date: (new Date()).toLocaleDateString(),
      lastDate: undefined,
      searchColumns: [
        {value: 'id', label: 'ID'},
        {value: 'title', label: 'Title'},
      ],
      tableColumns: [
        // columns.selection,
        columns.index,
        columns.id,
        {
          title: 'Title',
          render: (h, params) => {
            const title = params.row['title'];
            const url = params.row['url'];
            return h('a', { attrs: { href: url, target: "_blank" } }, title);
          },
        },
      ],
      tableData: undefined,
      totalData: 0,
      filter: undefined,
      pageAt: 1,
    };
  },
  watch: {
    date(val, oldVal) {
      if (oldVal && oldVal instanceof Date) {
        this.lastDate = oldVal.toLocaleDateString();
      }
    }
  },
  methods: {
    ...actions,
  },
  mounted() {
    this.$displayBodyBlock(false);
  },
}
</script>

<style lang="scss" scoped>
  @import "../../../assets/css/mixin";
  .investor-news {
    .search-btn {
      margin-left: 10px;
      @include circle-div-btn(32);
    }
    .page-message {
      font-size: 16px;
    }
    .crawling-message {
      font-size: 16px;
    }
    .crawled-btn {
      margin-left: 10px;
      @include circle-div-btn(32);
    }
  }
</style>
